<?php 

/**
 * Formulaire pour créer une image
 * (des champs textes s'affichant dans un rectangle)
 */
if (!defined('_ECRIRE_INC_VERSION')) return;
 
 include_spip('inc/actions');
 include_spip('inc/editer');
      
/**
 * Déclaration des champs du formulaire
 *
 * Références des vérifications :
 * @link: https://contrib.spip.net/References-des-verifications
 */
function formulaires_editer_pdform_image_saisies_dist($id_pdform_image='new', $retour='', $associer_objet = '', $lier_trad=0, $config_fonc='', $row=array(), $hidden=''){
	$id_image = intval($id_pdform_image);
	
	
	$saisies = array(
		array( // le champ éditable
			'saisie' => 'fieldset',
			'options' => array(
				'nom' => 'fieldset_cadrage',
				'label' => _T('pdform_image:fieldset_champ_cadrage_label'),
				'explication' => _T('pdform_image:fieldset_champ_cadrage_explication'),
			),
			'saisies' => array( // les champs dans le fieldset 
				array(
				'saisie' => 'hidden', // l'identifiant unique de la image
				'options' => array(
					'nom' => 'id_pdform_image',
					'defaut' => $id_image,
				),
				),
				array(
					'saisie' => 'hidden', // l'association éventuelle
					'options' => array(
						'nom' => 'associer_objet',
						'defaut' => $associer_objet,
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'titre',
						'label' => _T('pdform_image:champ_titre_label'),
						'explication' => _T('pdform_image:champ_titre_explication'),
					),
				),
				'verifier' => array( // le nombre est de type float
					'type' => 'taille',
					'options' => array(
						'maxi' => '255',
						'min' => '0',
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'imgfile',
						'label' => _T('pdform_image:champ_imgfile_label'),
						'explication' => _T('pdform_image:champ_imgfile_explication'),
					),
				),
				'verifier' => array( // si c'est url web vérifier qu'elle existe
					'type' => 'url_exist',
					'options' => array(
						'mode' => 'cool',
					)
				),
			),
		),
		array( // le fieldset XY
			'saisie' => 'fieldset',
			'options' => array(
				'nom' => 'fieldset_mesures',
				'label' => _T('pdform_image:fieldset_mesures_label'),
				'explication' => _T('pdform_image:fieldset_mesures_explication'),
			),
			'saisies' => array( // les champs dans le fieldset 
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'imgx',
						'label' => _T('pdform_image:champ_imgx_label'),
						#'explication' => _T('pdform_image:champ_setx_explication'),
					),
				),
				'verifier' => array( // le nombre est de type float
					'type' => 'decimal',
					'options' => array(
						'maxi' => '1000',
						'min' => '0',
						'nb_decimales' => '2',
						'normaliser' => 'oui',
						'separateur' => '.',
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'imgy',
						'label' => _T('pdform_image:champ_imgy_label'),
						#'explication' => _T('pdform_image:champ_sety_explication'),
					),
				),
				'verifier' => array( // le nombre est de type float
					'type' => 'decimal',
					'options' => array(
						'maxi' => '1000',
						'min' => '0',
						'nb_decimales' => '2',
						'normaliser' => 'oui',
						'separateur' => '.',
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'imgw',
						'label' => _T('pdform_image:champ_imgw_label'),
						'explication' => _T('pdform_image:champ_imgw_explication'),
					),
				),
				'verifier' => array( // le nombre est de type float
					'type' => 'decimal',
					'options' => array(
						'maxi' => '1000',
						'min' => '0',
						'nb_decimales' => '2',
						'normaliser' => 'oui',
						'separateur' => '.',
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'imgh',
						'label' => _T('pdform_image:champ_imgh_label'),
						'explication' => _T('pdform_image:champ_imgh_explication'),
						'defaut' => '5',
					),
				),
				'verifier' => array( // le nombre est de type float
					'type' => 'decimal',
					'options' => array(
						'maxi' => '1000',
						'min' => '0',
						'nb_decimales' => '2',
						'normaliser' => 'oui',
						'separateur' => '.',
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'imglink',
						'label' => _T('pdform_image:champ_imglink_label'),
						'explication' => _T('pdform_image:champ_imglink_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'url',
				),
			),
		),
		array( // le fieldset d'association
			'saisie' => 'fieldset',
			'options' => array(
				'afficher_si'=> '@associer_objet@ != ""',
				'nom' => 'association',
				'label' => _T('pdform_cellule:fieldset_association'),
				#'icone' => $icone_objet,
			),
			'saisies' => array( // les champs dans le fieldset 
				array( 
					'saisie' => 'case',
					'options' => array(
						'nom' => 'c_associe',
						'label' => _T('pdform_cellule:texte_associer_cellule_a', array('str' => _T(strstr($associer_objet,'|',true).':titre_'.strstr($associer_objet,'|',true)), 'nb' => substr(strstr(_request('associer_objet'),'|'),1))),
						'valeur_oui' => 'oui', 
						'valeur_non' => 'non',
						'defaut' => 'oui',
					)
				),
			)
		)
	);

	return $saisies;
}

/**
  * Identifier le formulaire en faisant abstraction des parametres qui ne representent pas l'objet edite
  */
function formulaires_editer_pdform_image_identifier_dist($id_pdform_image='new', $retour='', $associer_objet = '', $lier_trad=0, $config_fonc='', $row=array(), $hidden=''){
	return serialize(array(intval($id_pdform_image), $associer_objet));
}
 
/**
  * Declarer les champs postes et y integrer les valeurs par defaut
  */
function formulaires_editer_pdform_image_charger_dist($id_pdform_image='new', $retour='', $associer_objet = '', $lier_trad=0, $config_fonc='', $row=array(), $hidden=''){
	// Initialisation des valeurs à transmettre au formulaire
 	$valeurs = array();

	$valeurs = formulaires_editer_objet_charger('pdform_image',$id_pdform_image,'',$lier_trad,$retour,$config_fonc,$row,$hidden);

	# Une association 
	$valeurs['associer_objet'] = $associer_objet ? $associer_objet : _request('associer_objet');
	if ($valeurs['associer_objet']) {
		$valeurs['c_associer'] = 'oui';
	}
	
	return $valeurs;
}


/**
  * Traiter les champs postes
  */
function formulaires_editer_pdform_image_traiter_dist($id_pdform_image='new', $retour='', $associer_objet = '', $lier_trad=0, $config_fonc='', $row=array(), $hidden=''){

	$associer_objet = _request('associer_objet');
	// rompre l'association si nécessaire
	if (_request('c_associe') == 'non'){
		$associer_objet = '';
	}

	$retours = formulaires_editer_objet_traiter('pdform_image',$id_pdform_image,'',$lier_trad,$retour,$config_fonc,$row,$hidden);

	// Un lien a prendre en compte ?
 	if ($associer_objet and $id_pdform_image = $retours['id_pdform_image']) {
 		list($objet, $id_objet) = explode('|', $associer_objet);
 		if ($objet and $id_objet == intval($id_objet)) {
 			include_spip('action/editer_liens');
 			objet_associer(array('pdform_image' => $id_pdform_image), array($objet => $id_objet));
			// rediriger vers l'objet
			if (isset($redirect)) {
				$retours['redirect'] = parametre_url($redirect, 'id_lien_ajoute', $id_pdform_image, '&');
			}
 		}
 	}
	return $retours;

}
